image: maven:3.9.6-eclipse-temurin-17-alpine

variables:
  MAVEN_CLI_OPTS: "-s .m2/settings.xml --batch-mode"
  MAVEN_OPTS: "-Dmaven.repo.local=.m2/repository"

include:
  - template: Code-Quality.gitlab-ci.yml

cache:
  paths:
  - .m2/repository/

stages:
- build
- test
- deploy
- quality

build:
  stage: build
  script:
  - mvn $MAVEN_CLI_OPTS -P examples compile
  artifacts:
    expire_in: 1 day
    paths:
    - '*/target/*'

test:
  stage: test
  script:
  - mvn $MAVEN_CLI_OPTS -P examples test
  artifacts:
    expire_in: 1 day
    paths:
    - '*/target/*'
    reports:
      junit:
      - '*/target/surefire-reports/TEST-*.xml'
      - '*/target/failsafe-reports/TEST-*.xml'

deploy:
  stage: deploy
  script:
  - mvn $MAVEN_CLI_OPTS deploy
  only:
  - master

code_quality:
  stage: quality
  needs:
    - test
  artifacts:
    paths: [gl-code-quality-report.json]
    expire_in: 4 weeks
